GeoTessCPP 2.6.1 Software to facilitate storage and retrieval of 3D information about the Earth.

Loading...
Searching...
No Matches
geotess::GeoTessDataArray< T > Class Template Reference

Manages a 1D array of data values attached to a single grid node. More...

`#include <GeoTessDataArray.h>`

Inheritance diagram for geotess::GeoTessDataArray< T >:

## Public Member Functions
| GeoTessDataArray (T v[], const int &n)
| GeoTessDataArray (const vector< T > &v)
| GeoTessDataArray (const int &n)
virtual const GeoTessDataType & | getDataType () const
virtual int | size () const
virtual LONG_INT | getMemory ()
bool | operator== (const GeoTessDataArray< T > &d) const
virtual bool | operator== (const GeoTessData &d) const
virtual double | getDouble (int attributeIndex) const
virtual float | getFloat (int attributeIndex) const
virtual LONG_INT | getLong (int attributeIndex) const
virtual int | getInt (int attributeIndex) const
virtual short | getShort (int attributeIndex) const
virtual byte | getByte (int attributeIndex) const
virtual void | getValue (int attributeIndex, double &val) const
virtual void | getValue (int attributeIndex, float &val) const
virtual void | getValue (int attributeIndex, LONG_INT &val) const
virtual void | getValue (int attributeIndex, int &val) const
virtual void | getValue (int attributeIndex, short &val) const
virtual void | getValue (int attributeIndex, byte &val) const
virtual void | getValues (double vals[], const int &n)
virtual void | getValues (float vals[], const int &n)
virtual void | getValues (LONG_INT vals[], const int &n)
virtual void | getValues (int vals[], const int &n)
virtual void | getValues (short vals[], const int &n)
virtual void | getValues (byte vals[], const int &n)
virtual GeoTessData & | setValue (int attributeIndex, double v)
virtual GeoTessData & | setValue (int attributeIndex, float v)
virtual GeoTessData & | setValue (int attributeIndex, LONG_INT v)
virtual GeoTessData & | setValue (int attributeIndex, int v)
virtual GeoTessData & | setValue (int attributeIndex, short v)
virtual GeoTessData & | setValue (int attributeIndex, byte v)
virtual bool | isNaN (int attributeIndex) const
virtual GeoTessDataArray< T > * | copy ()
Public Member Functions inherited from geotess::GeoTessData
virtual int | class_size () const
template<typename T>
void | fill (T fillValue)

## Additional Inherited Members
Static Public Member Functions inherited from geotess::GeoTessData
static string | class_name ()
static int | class_count ()
static GeoTessData * | getData (const GeoTessDataType &dataType, int nAttributes)
static GeoTessData * | getData (double values[], const int &size)
static GeoTessData * | getData (const vector< double > &values)
static GeoTessData * | getData (float values[], const int &size)
static GeoTessData * | getData (const vector< float > &values)
static GeoTessData * | getData (LONG_INT values[], const int &size)
static GeoTessData * | getData (const vector< LONG_INT > &values)
static GeoTessData * | getData (int values[], const int &size)
static GeoTessData * | getData (const vector< int > &values)
static GeoTessData * | getData (short values[], const int &size)
static GeoTessData * | getData (const vector< short > &values)
static GeoTessData * | getData (byte values[], const int &size)
static GeoTessData * | getData (const vector< byte > &values)

## Detailed Description

template<typename T>
class geotess::GeoTessDataArray< T >

Manages a 1D array of data values attached to a single grid node.

Manages the data values attached to single grid node defined as an array of T type attributes (See DataType for supported types). The size of the array is always nAttributes as defined in the Data object.

Definition at line 72 of file GeoTessDataArray.h.

## Constructor & Destructor Documentation

## ◆ GeoTessDataArray() [1/3]

template<typename T>

geotess::GeoTessDataArray< T >::GeoTessDataArray | ( | T | v[],
|  | const int & | n )
| inline

Standard constructor. Copies the contents of the new DataArray from the provided input array.

Definition at line 97 of file GeoTessDataArray.h.

## ◆ GeoTessDataArray() [2/3]

template<typename T>

geotess::GeoTessDataArray< T >::GeoTessDataArray | ( | const vector< T > & | v | ) |
| inline

Standard constructor. Copies the contents of the new DataArray from the provided input array.

Definition at line 107 of file GeoTessDataArray.h.

## ◆ GeoTessDataArray() [3/3]

template<typename T>

geotess::GeoTessDataArray< T >::GeoTessDataArray | ( | const int & | n | ) |
| inline

Standard constructor. Creates a new array of n entries and initializes each to 0

Definition at line 116 of file GeoTessDataArray.h.

## Member Function Documentation

## ◆ copy()

template<typename T>

virtual GeoTessDataArray< T > * geotess::GeoTessDataArray< T >::copy | ( |  | ) |
| inline virtual

Returns a deep copy of this DataArray<T> object.

Definition at line 420 of file GeoTessDataArray.h.

## ◆ getByte()

template<typename T>

virtual byte geotess::GeoTessDataArray< T >::getByte | ( | int | attributeIndex | ) | const
| inline virtual

Returns value defined for the input attribute index as a byte

Reimplemented from geotess::GeoTessData.

Definition at line 293 of file GeoTessDataArray.h.

## ◆ getDataType()

template<typename T>

virtual const GeoTessDataType & geotess::GeoTessDataArray< T >::getDataType | ( |  | ) | const
| inline virtual

Retrieve the DataType of this Data object. One of DOUBLE, FLOAT, LONG, INT SHORT, BYTE

Returns
  the DataType of this Data object.

Reimplemented from geotess::GeoTessData.

Definition at line 227 of file GeoTessDataArray.h.

## ◆ getDouble()

template<typename T>

virtual double geotess::GeoTessDataArray< T >::getDouble | ( | int | attributeIndex | ) | const
| inline virtual

Returns value defined for the input attribute index as a double

Reimplemented from geotess::GeoTessData.

Definition at line 263 of file GeoTessDataArray.h.

## ◆ getFloat()

template<typename T>

virtual float geotess::GeoTessDataArray< T >::getFloat | ( | int | attributeIndex | ) | const
| inline virtual

Returns value defined for the input attribute index as a float

Reimplemented from geotess::GeoTessData.

Definition at line 269 of file GeoTessDataArray.h.

## ◆ getInt()

template<typename T>

virtual int geotess::GeoTessDataArray< T >::getInt | ( | int | attributeIndex | ) | const
| inline virtual

Returns value defined for the input attribute index as an int

Reimplemented from geotess::GeoTessData.

Definition at line 281 of file GeoTessDataArray.h.

## ◆ getLong()

template<typename T>

virtual LONG_INT geotess::GeoTessDataArray< T >::getLong | ( | int | attributeIndex | ) | const
| inline virtual

Returns value defined for the input attribute index as a long

Reimplemented from geotess::GeoTessData.

Definition at line 275 of file GeoTessDataArray.h.

## ◆ getMemory()

template<typename T>

virtual LONG_INT geotess::GeoTessDataArray< T >::getMemory | ( |  | ) |
| inline virtual

Reimplemented from geotess::GeoTessData.

Definition at line 234 of file GeoTessDataArray.h.

## ◆ getShort()

template<typename T>

virtual short geotess::GeoTessDataArray< T >::getShort | ( | int | attributeIndex | ) | const
| inline virtual

Returns value defined for the input attribute index as a short

Reimplemented from geotess::GeoTessData.

Definition at line 287 of file GeoTessDataArray.h.

## ◆ getValue() [1/6]

template<typename T>

virtual void geotess::GeoTessDataArray< T >::getValue | ( | int | attributeIndex,
|  | byte & | val ) const
| inline virtual

Returns the attribute at the input attribute index as a byte value.

Reimplemented from geotess::GeoTessData.

Definition at line 329 of file GeoTessDataArray.h.

## ◆ getValue() [2/6]

template<typename T>

virtual void geotess::GeoTessDataArray< T >::getValue | ( | int | attributeIndex,
|  | double & | val ) const
| inline virtual

Returns the attribute at the input attribute index as a double value.

Reimplemented from geotess::GeoTessData.

Definition at line 299 of file GeoTessDataArray.h.

## ◆ getValue() [3/6]

template<typename T>

virtual void geotess::GeoTessDataArray< T >::getValue | ( | int | attributeIndex,
|  | float & | val ) const
| inline virtual

Returns the attribute at the input attribute index as a float value.

Reimplemented from geotess::GeoTessData.

Definition at line 305 of file GeoTessDataArray.h.

## ◆ getValue() [4/6]

template<typename T>

virtual void geotess::GeoTessDataArray< T >::getValue | ( | int | attributeIndex,
|  | int & | val ) const
| inline virtual

Returns the attribute at the input attribute index as a int value.

Reimplemented from geotess::GeoTessData.

Definition at line 317 of file GeoTessDataArray.h.

## ◆ getValue() [5/6]

template<typename T>

virtual void geotess::GeoTessDataArray< T >::getValue | ( | int | attributeIndex,
|  | LONG_INT & | val ) const
| inline virtual

Returns the attribute at the input attribute index as a long value.

Reimplemented from geotess::GeoTessData.

Definition at line 311 of file GeoTessDataArray.h.

## ◆ getValue() [6/6]

template<typename T>

virtual void geotess::GeoTessDataArray< T >::getValue | ( | int | attributeIndex,
|  | short & | val ) const
| inline virtual

Returns the attribute at the input attribute index as a short value.

Reimplemented from geotess::GeoTessData.

Definition at line 323 of file GeoTessDataArray.h.

## ◆ getValues() [1/6]

template<typename T>

virtual void geotess::GeoTessDataArray< T >::getValues | ( | byte | vals[],
|  | const int & | n )
| inline virtual

Copy the first n values into the supplied array as a byte value.

Reimplemented from geotess::GeoTessData.

Definition at line 365 of file GeoTessDataArray.h.

## ◆ getValues() [2/6]

template<typename T>

virtual void geotess::GeoTessDataArray< T >::getValues | ( | double | vals[],
|  | const int & | n )
| inline virtual

Copy the first n values into the supplied array as a double value.

Reimplemented from geotess::GeoTessData.

Definition at line 335 of file GeoTessDataArray.h.

## ◆ getValues() [3/6]

template<typename T>

virtual void geotess::GeoTessDataArray< T >::getValues | ( | float | vals[],
|  | const int & | n )
| inline virtual

Copy the first n values into the supplied array as a float value.

Reimplemented from geotess::GeoTessData.

Definition at line 341 of file GeoTessDataArray.h.

## ◆ getValues() [4/6]

template<typename T>

virtual void geotess::GeoTessDataArray< T >::getValues | ( | int | vals[],
|  | const int & | n )
| inline virtual

Copy the first n values into the supplied array as an int value.

Reimplemented from geotess::GeoTessData.

Definition at line 353 of file GeoTessDataArray.h.

## ◆ getValues() [5/6]

template<typename T>

virtual void geotess::GeoTessDataArray< T >::getValues | ( | LONG_INT | vals[],
|  | const int & | n )
| inline virtual

Copy the first n values into the supplied array as a LONG_INT value.

Reimplemented from geotess::GeoTessData.

Definition at line 347 of file GeoTessDataArray.h.

## ◆ getValues() [6/6]

template<typename T>

virtual void geotess::GeoTessDataArray< T >::getValues | ( | short | vals[],
|  | const int & | n )
| inline virtual

Copy the first n values into the supplied array as a short value.

Reimplemented from geotess::GeoTessData.

Definition at line 359 of file GeoTessDataArray.h.

## ◆ isNaN()

template<typename T>

virtual bool geotess::GeoTessDataArray< T >::isNaN | ( | int | attributeIndex | ) | const
| inline virtual

Returns true if the specified attribute is NaN. when Data values are of type Byte, Short, Int and Long, this method always returns false since those types do not support NaN. float and double types are overridden and returns true if value isNaN and false otherwise.

Parameters

  attributeIndex | The attribute value to be tested.

Returns
  true if the value of the specified attribute is NaN.

Reimplemented from geotess::GeoTessData.

Definition at line 415 of file GeoTessDataArray.h.

## ◆ operator==() [1/2]

template<typename T>

virtual bool geotess::GeoTessDataArray< T >::operator== | ( | const GeoTessData & | d | ) | const
| inline virtual

Return true if the input DataArray<T> object (d) equals this DataArray<T> object.

Reimplemented from geotess::GeoTessData.

Definition at line 257 of file GeoTessDataArray.h.

## ◆ operator==() [2/2]

template<typename T>

bool geotess::GeoTessDataArray< T >::operator== | ( | const GeoTessDataArray< T > & | d | ) | const
| inline

Return true if the input DataArray<T> object (d) equals this DataArray<T> object.

Definition at line 241 of file GeoTessDataArray.h.

## ◆ setValue() [1/6]

template<typename T>

virtual GeoTessData & geotess::GeoTessDataArray< T >::setValue | ( | int | attributeIndex,
|  | byte | v )
| inline virtual

Set the value at the input attribute index to the input value.

Reimplemented from geotess::GeoTessData.

Definition at line 401 of file GeoTessDataArray.h.

## ◆ setValue() [2/6]

template<typename T>

virtual GeoTessData & geotess::GeoTessDataArray< T >::setValue | ( | int | attributeIndex,
|  | double | v )
| inline virtual

Set the value at the input attribute index to the input value.

Reimplemented from geotess::GeoTessData.

Definition at line 371 of file GeoTessDataArray.h.

## ◆ setValue() [3/6]

template<typename T>

virtual GeoTessData & geotess::GeoTessDataArray< T >::setValue | ( | int | attributeIndex,
|  | float | v )
| inline virtual

Set the value at the input attribute index to the input value.

Reimplemented from geotess::GeoTessData.

Definition at line 377 of file GeoTessDataArray.h.

## ◆ setValue() [4/6]

template<typename T>

virtual GeoTessData & geotess::GeoTessDataArray< T >::setValue | ( | int | attributeIndex,
|  | int | v )
| inline virtual

Set the value at the input attribute index to the input value.

Reimplemented from geotess::GeoTessData.

Definition at line 389 of file GeoTessDataArray.h.

## ◆ setValue() [5/6]

template<typename T>

virtual GeoTessData & geotess::GeoTessDataArray< T >::setValue | ( | int | attributeIndex,
|  | LONG_INT | v )
| inline virtual

Set the value at the input attribute index to the input value.

Reimplemented from geotess::GeoTessData.

Definition at line 383 of file GeoTessDataArray.h.

## ◆ setValue() [6/6]

template<typename T>

virtual GeoTessData & geotess::GeoTessDataArray< T >::setValue | ( | int | attributeIndex,
|  | short | v )
| inline virtual

Set the value at the input attribute index to the input value.

Reimplemented from geotess::GeoTessData.

Definition at line 395 of file GeoTessDataArray.h.

## ◆ size()

template<typename T>

virtual int geotess::GeoTessDataArray< T >::size | ( |  | ) | const
| inline virtual

Returns the number of entries in the array of values.

Reimplemented from geotess::GeoTessData.

Definition at line 232 of file GeoTessDataArray.h.

The documentation for this class was generated from the following files:

- rstt_v3.2.1/GeoTessCPP/include/GeoTessData.h
- rstt_v3.2.1/GeoTessCPP/include/GeoTessDataArray.h